image: docker:latest
services :
  - name : docker:dind
    alias : docker

stages :
  - build-image
  - test-acceptation
  - release-image
  - deploy-review
  - stop-review
  - deploy-staging
  - test-staging
  - deploy-prod
  - test-prod

.test_template : &test
  image : alpine
  only :
    - master
  script :
    - apk --no-cache add curl
    - curl "https://$DOMAIN" | grep -q "Hello world!"
  #environment :
  #  url : https://$DOMAIN

build-image :
  stage: build-image
  script :
    - docker build -t alpinehelloworld .
    - docker save alpinehelloworld > alpinehelloworld.tar
  artifacts :
    paths : 
      - alpinehelloworld.tar

test-acceptation:
  stage: test-acceptation
  script :
    - docker load < alpinehelloworld.tar
    - docker run -d -p 80:5000 -e PORT=5000 --name webapp alpinehelloworld
    - sleep 5
    - apk --no-cache add curl
    - curl "http://docker" | grep -q "Hello world!"

release-image :
  stage : release-image
  script :
    - docker load < alpinehelloworld.tar
    - docker tag alpinehelloworld "${IMAGE_NAME}:${CI_COMMIT_REF_NAME}"
    - docker tag alpinehelloworld "${IMAGE_NAME}:${CI_COMMIT_SHORT_SHA}"
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker push "${IMAGE_NAME}:${CI_COMMIT_REF_NAME}"
    - docker push "${IMAGE_NAME}:${CI_COMMIT_SHORT_SHA}"

deploy-staging :
  stage : deploy-staging
  environment :
    name : staging
    url : https://loyem-staging.herokuapp.com
  only:
    - master
  script :
    - apk --no-cache add npm 
    - npm install -g heroku
    - heroku container:login
    - heroku create loyem-staging || echo "project already exist"
    - heroku container:push -a loyem-staging web
    - heroku container:release -a loyem-staging web

deploy-prod :
  stage : deploy-prod
  environment :
    name : prod
    url : https://loyem-prod.herokuapp.com
  only:
    - master
  script :
    - apk --no-cache add npm 
    - npm install -g heroku
    - heroku container:login
    - heroku create loyem-prod || echo "project already exist"
    - heroku container:push -a loyem-prod web
    - heroku container:release -a loyem-prod web

deploy-review :
  stage: deploy-review
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://loyem-$CI_COMMIT_REF_NAME.herokuapp.com
    on_stop: stop-review
  only:
    - merge_requests
  script:
    - apk --no-cache add npm
    - npm install -g heroku
    - heroku container:login
    - heroku create loyem-$CI_COMMIT_REF_NAME  || echo "project already exist"
    - heroku container:push -a loyem-$CI_COMMIT_REF_NAME web
    - heroku container:release -a loyem-$CI_COMMIT_REF_NAME web

stop-review:
  stage: stop-review
  variables:
    GIT_STRATEGY: none
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
  only:
    - merge_requests
  when: manual
  script:
    - apk --no-cache add npm
    - npm install -g heroku
    - heroku container:login
    - heroku apps:destroy -a loyem-$CI_COMMIT_REF_NAME -c loyem-$CI_COMMIT_REF_NAME

test-staging :
  <<: *test
  stage: test-staging
  variables : 
    DOMAIN: loyem-staging.herokuapp.com

test-prod :
  <<: *test
  stage: test-prod
  variables : 
    DOMAIN: loyem-prod.herokuapp.com
